; ==================================================================================================
; Title:     CreatePathA.asm
; Author:    G. Friedrich / J. Trudgen
; Version:   1.0.0
; Notes:     Version 1.0.0, September 2002.
;              - First release.
; ==================================================================================================


% include @Environ(OA32_PATH)\\Code\\OA32_Setup.inc
% include &ObjMemPath&ObjMem32.cop
% include &MacPath&Strings.inc
% include &IncPath&Windows.inc
% include &IncPath&User32.inc
% include &IncPath&Kernel32.inc

.code

align ALIGN_CODE

; 
; Procedure: CreatePathA
; Purpose:   Creates a path on the destination drive.
; Arguments: Arg1: -> ANSI path string.
; Return:    Nothing.

CreatePathA proc uses ebx esi pPathNameA:Pointer
    local FFD:WIN32_FIND_DATA
    local bBuffer[MAX_PATH]:byte

    invoke StrECopyA, addr bBuffer, pPathNameA
    FillStringA [eax], <\\*.*>
    invoke FindFirstFileA, addr bBuffer, addr FFD
    cmp eax, INVALID_HANDLE_VALUE
    je @@0
    invoke FindClose, eax                ;Directory just exists!
    mov eax, TRUE
    jmp @@Exit
@@0:
    mov ebx, pPathNameA
    invoke StrScanA, ebx, "\"
    or eax, eax
    jz @@Exit
    inc eax
    mov esi, eax
@@1:
    invoke StrScanA, esi, "\"
    mov esi, eax
    or eax, eax
    je @@2
    sub eax, ebx
    invoke StrLCopyA, addr bBuffer, ebx, eax
    jmp @@3
@@2:
    invoke StrCopyA, addr bBuffer, ebx
@@3:
    invoke CreateDirectoryA, addr bBuffer, NULL
    or esi, esi
    jz @@Exit
    inc esi
    jmp @@1
@@Exit:
    ret
CreatePathA endp

end