; ==================================================================================================
; Title:     CreatePathW.asm
; Author:    G. Friedrich
; Version:   1.0.0
; Notes:     Version 1.0.0, December 2010.
;              - First release.
; ==================================================================================================


% include @Environ(OA32_PATH)\\Code\\OA32_Setup.inc
% include &ObjMemPath&ObjMem32.cop
% include &MacPath&Strings.inc
% include &IncPath&Windows.inc
% include &IncPath&User32.inc
% include &IncPath&Kernel32.inc

WIN32_FIND_DATAW STRUCT
  dwFileAttributes      DWORD      ?
  ftCreationTime        FILETIME <>
  ftLastAccessTime      FILETIME <>
  ftLastWriteTime       FILETIME <>
  nFileSizeHigh         DWORD      ?
  nFileSizeLow          DWORD      ?
  dwReserved0           DWORD      ?
  dwReserved1           DWORD      ?
  cFileName             WORD MAX_PATH dup(?)
  cAlternate            WORD 14 dup(?)
WIN32_FIND_DATAW ENDS
LPWIN32_FIND_DATAW typedef ptr WIN32_FIND_DATAW

.code

align ALIGN_CODE

; 
; Procedure: CreatePathW
; Purpose:   Creates a path on the destination drive.
; Arguments: Arg1: -> Wide path string.
; Return:    Nothing.

CreatePathW proc uses ebx esi pPathNameW:Pointer
    local FFD:WIN32_FIND_DATAW
    local wBuffer[MAX_PATH]:word

    invoke StrECopyW, addr wBuffer, pPathNameW
    FillStringW [eax], <\\*.*>
    invoke FindFirstFileW, addr wBuffer, addr FFD
    cmp eax, INVALID_HANDLE_VALUE
    je @@0
    invoke FindClose, eax                ;Directory just exists!
    mov eax, TRUE
    jmp @@Exit
@@0:
    mov ebx, pPathNameW
    invoke StrScanW, ebx, "\"
    or eax, eax
    jz @@Exit
    add eax, 2
    mov esi, eax
@@1:
    invoke StrScanW, esi, "\"
    mov esi, eax
    or eax, eax
    je @@2
    sub eax, ebx
    shr eax, 1
    invoke StrLCopyW, addr wBuffer, ebx, eax
    jmp @@3
@@2:
    invoke StrCopyW, addr wBuffer, ebx
@@3:
    invoke CreateDirectoryW, addr wBuffer, NULL
    or esi, esi
    jz @@Exit
    add esi, 2
    jmp @@1
@@Exit:
    ret
CreatePathW endp

end